_init_filter:
;fir.c,54 :: 		void init_filter(void)
;fir.c,57 :: 		for (i=0; i<N; i++)
; i start address is: 8 (R2)
MOVS	R2, #0
SXTH	R2, R2
; i end address is: 8 (R2)
L_init_filter0:
; i start address is: 8 (R2)
CMP	R2, #30
IT	GE
BGE	L_init_filter1
;fir.c,59 :: 		x[i]=0;
LSLS	R1, R2, #2
MOVW	R0, #lo_addr(_x+0)
MOVT	R0, #hi_addr(_x+0)
ADDS	R1, R0, R1
MOV	R0, #0
STR	R0, [R1, #0]
;fir.c,57 :: 		for (i=0; i<N; i++)
ADDS	R2, R2, #1
SXTH	R2, R2
;fir.c,60 :: 		}
; i end address is: 8 (R2)
IT	AL
BAL	L_init_filter0
L_init_filter1:
;fir.c,61 :: 		}
L_end_init_filter:
BX	LR
; end of _init_filter
_filter:
;fir.c,63 :: 		double filter(double x_in)
; x_in start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; x_in end address is: 0 (R0)
; x_in start address is: 0 (R0)
;fir.c,67 :: 		double y = 0.0;
; y start address is: 32 (R8)
MOV	R8, #0
;fir.c,70 :: 		x[n] = x_in;
MOVW	R1, #lo_addr(_n+0)
MOVT	R1, #hi_addr(_n+0)
LDRSH	R1, [R1, #0]
LSLS	R2, R1, #2
MOVW	R1, #lo_addr(_x+0)
MOVT	R1, #hi_addr(_x+0)
ADDS	R1, R1, R2
STR	R0, [R1, #0]
; x_in end address is: 0 (R0)
;fir.c,73 :: 		for (i=0; i<N; i++)
; i start address is: 36 (R9)
MOVW	R9, #0
SXTH	R9, R9
; y end address is: 32 (R8)
; i end address is: 36 (R9)
L_filter3:
; i start address is: 36 (R9)
; y start address is: 32 (R8)
CMP	R9, #30
IT	GE
BGE	L_filter4
;fir.c,75 :: 		y += h[i] * x[((N - i) + n) % N];
LSL	R2, R9, #2
MOVW	R1, #lo_addr(_h+0)
MOVT	R1, #hi_addr(_h+0)
ADDS	R1, R1, R2
LDR	R4, [R1, #0]
RSB	R2, R9, #30
SXTH	R2, R2
MOVW	R1, #lo_addr(_n+0)
MOVT	R1, #hi_addr(_n+0)
LDRSH	R1, [R1, #0]
ADDS	R3, R2, R1
SXTH	R3, R3
MOVS	R2, #30
SXTH	R2, R2
SDIV	R1, R3, R2
MLS	R1, R2, R1, R3
SXTH	R1, R1
LSLS	R2, R1, #2
MOVW	R1, #lo_addr(_x+0)
MOVT	R1, #hi_addr(_x+0)
ADDS	R1, R1, R2
LDR	R0, [R1, #0]
MOV	R2, R4
BL	__Mul_FP+0
MOV	R2, R8
BL	__Add_FP+0
MOV	R8, R0
;fir.c,73 :: 		for (i=0; i<N; i++)
ADD	R9, R9, #1
SXTH	R9, R9
;fir.c,76 :: 		}
; i end address is: 36 (R9)
IT	AL
BAL	L_filter3
L_filter4:
;fir.c,79 :: 		n = (n + 1) % N;
MOVW	R4, #lo_addr(_n+0)
MOVT	R4, #hi_addr(_n+0)
LDRSH	R1, [R4, #0]
ADDS	R3, R1, #1
SXTH	R3, R3
MOVS	R2, #30
SXTH	R2, R2
SDIV	R1, R3, R2
MLS	R1, R2, R1, R3
STRH	R1, [R4, #0]
;fir.c,81 :: 		return y;
MOV	R0, R8
; y end address is: 32 (R8)
;fir.c,82 :: 		}
L_end_filter:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _filter
